#property copyright "Copyright  2006, Nick Sparrow"   

//Input variable that can be edited by the user when testing
//These varieable are those found under the input tab when looking at the EA's properties

extern string access             = "--------- Registration Access ---------"; //heading
extern string password           = "NnCLLC";//this is set so that everyone can use it at the moment
extern string other_parameters   = "-------- Execution Management --------"; //heading
extern int stoploss              = 30;  //This is your user defined s/l
extern int takeprofit            = 30;  //This is your user defined t/p
extern int barspread             = 10; //How much the bar has to spread apart before a trade will execute
extern int max_trades            = 1;  //Max number of trades that can be executed at any one given time       
extern int ema_period            = 20; //sets the period of the ema
extern string  mm_parameters     = "---------- Money Management ----------";//Just a heading
extern bool money_management     = true; //Use Money Management or not
extern double lots               = 1;  //Number of lots to use.  It will increase lots with increased margin
extern int risk                  = 10; //How much margin to risk 10%. Total risk is determined by your s/l
extern color conservative_buy    = CornflowerBlue;
extern color contervative_sell   = Red;

static int time_frame;
int summary = 0;
//A global variable but not one what can be manually changed in under the EA's properties
int ID=983783;         

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}
int deinit() {
   time_frame = Period();
   return(0);}

//Figure out how many lots to use
int subLotSize()
   {
   int lotMM = MathCeil(AccountFreeMargin() *  risk / 1000) / 100;
	   if(lotMM < 0.1)                  lotMM = lots;
	   if((lotMM > 0.5) && (lotMM < 1)) lotMM = lots;
	   if(lotMM > 1)                    lotMM = MathCeil(lotMM);
	   if(lotMM > 100)                  lotMM = 100;
	return (lotMM);
   }
  
int start()
  {
   if(password == "NnCLLC")
   { 
     double sl,tp,ticket,cnt,scalp_gap,minimum_minutes; //Variable that will be used to store sl and tp data
     int total_orders = OrdersTotal();
     //if (Period() < 30) {Comment("change to M30 or higher pls"); return(0); }      
   
     if(money_management)lots = subLotSize(); //If MM is true then execute the MM function to increase lots with increasing margin
   
     //Summary of setup
     if (summary ==0){summary++;
        Print("Hello summary");}
 
     //If bar/candle has moved more than 10 pips in this time frame and if the open is less than the
     //average of the high and the low and at the current moment the ask is less than the open, go long
     if (orderscnt() < max_trades)
     {   
           //double previous_ma1 = iMA(NULL,1,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           //double current_ma1 = iMA(NULL,1,ema_period,0,MODE_EMA,PRICE_CLOSE,0);
           double previous_ma5 = iMA(NULL,5,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma5 = iMA(NULL,5,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           double previous_ma15 = iMA(NULL,15,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma15 = iMA(NULL,15,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           double previous_ma30 = iMA(NULL,30,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma30 = iMA(NULL,30,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           double previous_ma60 = iMA(NULL,60,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma60 = iMA(NULL,60,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           //double previous_ma240 = iMA(NULL,240,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           //double current_ma240 = iMA(NULL,240,ema_period,0,MODE_EMA,PRICE_CLOSE,0);
             
           if(Hour() >= 7 && Hour() < 15){ 
             if ((High[0]-Low[0]) > barspread*Point && Open[0]>(High[0]+Low[0])/2 && Bid >= Open[0]&&(current_ma5 < previous_ma5)
                 &&(current_ma15 < previous_ma15)&&(current_ma30 < previous_ma30)&&(current_ma60 < previous_ma60)
                 /*&&(current_ma240 < previous_ma240)*/){
              if(stoploss==0){sl=0;}else{sl=Ask-stoploss*Point;} 
              if(takeprofit==0){tp=0;}else{tp=Ask+takeprofit*Point;}
              ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,2,sl,tp,"ConservativeAntClassicBuy",ID,0,conservative_buy);
              Print("Ticket # ",ticket);
             }         
             if ((High[0]-Low[0]) > barspread*Point && Open[0]<(High[0]+Low[0])/2 && Ask <= Open[0]&&(current_ma5 > previous_ma5)
                 &&(current_ma15 > previous_ma15)&&(current_ma30 > previous_ma30)&&(current_ma60 > previous_ma60)
                 /*&&(current_ma240 > previous_ma240)*/){    
              if(stoploss==0){sl=0;}else{sl=Bid+stoploss*Point;}
              if(takeprofit==0){tp=0;}else{tp=Bid-takeprofit*Point;}
              ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,2,sl,tp,"ConservativeAntClassicSell",ID,0,contervative_sell);
              Print("Ticket # ",ticket); 
             }
           }//if(hour stuff)
           else{
             if ((High[0]-Low[0]) > barspread*Point && Open[0]<(High[0]+Low[0])/2 && Ask <= Open[0]&&(current_ma5 > previous_ma5)
                 &&(current_ma15 > previous_ma15)&&(current_ma30 > previous_ma30)&&(current_ma60 > previous_ma60)
                 /*&&(current_ma240 > previous_ma240)*/){
              if(stoploss==0){sl=0;}else{sl=Ask-stoploss*Point;} 
              if(takeprofit==0){tp=0;}else{tp=Ask+takeprofit*Point;}
              ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,2,sl,tp,"ConservativeAntClassicBuy",ID,0,conservative_buy);
              Print("Ticket # ",ticket);
             }         
             if ((High[0]-Low[0]) > barspread*Point && Open[0]>(High[0]+Low[0])/2 && Bid >= Open[0]&&(current_ma5 < previous_ma5)
                 &&(current_ma15 < previous_ma15)&&(current_ma30 < previous_ma30)&&(current_ma60 < previous_ma60)
                 /*&&(current_ma240 < previous_ma240)*/){
              if(stoploss==0){sl=0;}else{sl=Bid+stoploss*Point;}
              if(takeprofit==0){tp=0;}else{tp=Bid-takeprofit*Point;}
              ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,2,sl,tp,"ConservativeAntClassicSell",ID,0,contervative_sell);
              Print("Ticket # ",ticket); 
             }
           }//else                         
      }//if (total_orders < max_trades)
    }//if password
    return(0);
   }  

